<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BorderCrossingSelection_V2 StructType
 * @subpackage Structs
 */
class BorderCrossingSelection_V2 extends AbstractStructBase
{
    /**
     * The IncludeTachoTimes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeTachoTimes;
    /**
     * The IncludeObcTimes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeObcTimes;
    /**
     * The IncludeCoDriverData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeCoDriverData;
    /**
     * The IncludeFuelLevel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeFuelLevel;
    /**
     * The DateStrategySelection
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateStrategySelection
     */
    public $DateStrategySelection;
    /**
     * The Vehicles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Vehicles;
    /**
     * The Drivers
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifier
     */
    public $Drivers;
    /**
     * Constructor method for BorderCrossingSelection_V2
     * @uses BorderCrossingSelection_V2::setIncludeTachoTimes()
     * @uses BorderCrossingSelection_V2::setIncludeObcTimes()
     * @uses BorderCrossingSelection_V2::setIncludeCoDriverData()
     * @uses BorderCrossingSelection_V2::setIncludeFuelLevel()
     * @uses BorderCrossingSelection_V2::setDateStrategySelection()
     * @uses BorderCrossingSelection_V2::setVehicles()
     * @uses BorderCrossingSelection_V2::setDrivers()
     * @param bool $includeTachoTimes
     * @param bool $includeObcTimes
     * @param bool $includeCoDriverData
     * @param bool $includeFuelLevel
     * @param \StructType\DateStrategySelection $dateStrategySelection
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @param \ArrayType\ArrayOfIdentifier $drivers
     */
    public function __construct($includeTachoTimes = null, $includeObcTimes = null, $includeCoDriverData = null, $includeFuelLevel = null, \StructType\DateStrategySelection $dateStrategySelection = null, \ArrayType\ArrayOfIdentifierVehicle $vehicles = null, \ArrayType\ArrayOfIdentifier $drivers = null)
    {
        $this
            ->setIncludeTachoTimes($includeTachoTimes)
            ->setIncludeObcTimes($includeObcTimes)
            ->setIncludeCoDriverData($includeCoDriverData)
            ->setIncludeFuelLevel($includeFuelLevel)
            ->setDateStrategySelection($dateStrategySelection)
            ->setVehicles($vehicles)
            ->setDrivers($drivers);
    }
    /**
     * Get IncludeTachoTimes value
     * @return bool
     */
    public function getIncludeTachoTimes()
    {
        return $this->IncludeTachoTimes;
    }
    /**
     * Set IncludeTachoTimes value
     * @param bool $includeTachoTimes
     * @return \StructType\BorderCrossingSelection_V2
     */
    public function setIncludeTachoTimes($includeTachoTimes = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeTachoTimes) && !is_bool($includeTachoTimes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeTachoTimes, true), gettype($includeTachoTimes)), __LINE__);
        }
        $this->IncludeTachoTimes = $includeTachoTimes;
        return $this;
    }
    /**
     * Get IncludeObcTimes value
     * @return bool
     */
    public function getIncludeObcTimes()
    {
        return $this->IncludeObcTimes;
    }
    /**
     * Set IncludeObcTimes value
     * @param bool $includeObcTimes
     * @return \StructType\BorderCrossingSelection_V2
     */
    public function setIncludeObcTimes($includeObcTimes = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeObcTimes) && !is_bool($includeObcTimes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeObcTimes, true), gettype($includeObcTimes)), __LINE__);
        }
        $this->IncludeObcTimes = $includeObcTimes;
        return $this;
    }
    /**
     * Get IncludeCoDriverData value
     * @return bool
     */
    public function getIncludeCoDriverData()
    {
        return $this->IncludeCoDriverData;
    }
    /**
     * Set IncludeCoDriverData value
     * @param bool $includeCoDriverData
     * @return \StructType\BorderCrossingSelection_V2
     */
    public function setIncludeCoDriverData($includeCoDriverData = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeCoDriverData) && !is_bool($includeCoDriverData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeCoDriverData, true), gettype($includeCoDriverData)), __LINE__);
        }
        $this->IncludeCoDriverData = $includeCoDriverData;
        return $this;
    }
    /**
     * Get IncludeFuelLevel value
     * @return bool
     */
    public function getIncludeFuelLevel()
    {
        return $this->IncludeFuelLevel;
    }
    /**
     * Set IncludeFuelLevel value
     * @param bool $includeFuelLevel
     * @return \StructType\BorderCrossingSelection_V2
     */
    public function setIncludeFuelLevel($includeFuelLevel = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeFuelLevel) && !is_bool($includeFuelLevel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeFuelLevel, true), gettype($includeFuelLevel)), __LINE__);
        }
        $this->IncludeFuelLevel = $includeFuelLevel;
        return $this;
    }
    /**
     * Get DateStrategySelection value
     * @return \StructType\DateStrategySelection|null
     */
    public function getDateStrategySelection()
    {
        return $this->DateStrategySelection;
    }
    /**
     * Set DateStrategySelection value
     * @param \StructType\DateStrategySelection $dateStrategySelection
     * @return \StructType\BorderCrossingSelection_V2
     */
    public function setDateStrategySelection(\StructType\DateStrategySelection $dateStrategySelection = null)
    {
        $this->DateStrategySelection = $dateStrategySelection;
        return $this;
    }
    /**
     * Get Vehicles value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getVehicles()
    {
        return $this->Vehicles;
    }
    /**
     * Set Vehicles value
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @return \StructType\BorderCrossingSelection_V2
     */
    public function setVehicles(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this->Vehicles = $vehicles;
        return $this;
    }
    /**
     * Get Drivers value
     * @return \ArrayType\ArrayOfIdentifier|null
     */
    public function getDrivers()
    {
        return $this->Drivers;
    }
    /**
     * Set Drivers value
     * @param \ArrayType\ArrayOfIdentifier $drivers
     * @return \StructType\BorderCrossingSelection_V2
     */
    public function setDrivers(\ArrayType\ArrayOfIdentifier $drivers = null)
    {
        $this->Drivers = $drivers;
        return $this;
    }
}
